#include "common.h"
#include "blenders.h"
#include "hurteffect.h"
#define  HURTEFFECT_START     49
#define  HURTEFFECT_COUNTDOWN 2

static int     hurteffect_logic_count  = 0;

/******************************************************************************/

void HURTEFFECT_draw(void)
{
   static int sine_count;
   
   if (hurteffect_logic_count < 1) return;
   
   hurteffect_logic_count -= HURTEFFECT_COUNTDOWN;
   
   int sine_index;
   
   sine_count += 3;

   set_blender_mode(NULL, (BLENDER_FUNC)BLEND_add16, NULL, 0, 0, 0, hurteffect_logic_count);

   drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
   
   int redness = hurteffect_logic_count * 3; 
   
   if (redness < 0) redness = 0;
   
   rectfill(double_buffer, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT, 
      makecol(redness, 0, 0));

   drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
   
   for (sine_index = 0; sine_index < DISPLAY_HEIGHT; sine_index++)
   {
      blit(double_buffer, double_buffer, 0, sine_index, 
         sin((sine_index + sine_count) / 3.0f) * (hurteffect_logic_count / 4.5f), sine_index, DISPLAY_WIDTH, 1);
   }
}

/******************************************************************************/

void HURTEFFECT_reset(void)
{
   hurteffect_logic_count  = 0;
}

/******************************************************************************/

void HURTEFFECT_start(void)
{
   hurteffect_logic_count = HURTEFFECT_START;   
}

/******************************************************************************/

BOOL HURTEFFECT_check_done(void)
{
   return (hurteffect_logic_count < 1);
}
