/******************************************************************************
/*   This file is part of the game Virus Burst.
 *
 *   Virus Burst is free software: you can redistribute it and/or modify it
 *   under the terms of the WTF Public License.
 *
 *   Virus Burst is distributed in the hope that players will find it enjoyable,
 *   emotive, educational even, but with NO WARRANTY of any kind. What happens
 *   to your Pandora, your dog or your sanity as a result of this is solely
 *   YOUR responsibility.
 *
 *   You should have received a copy of the WTF Public License
 *   along with the game (please see the file COPYING).  If not,
 *   please refer to <http://www.wtfpl.net/about/>.
 */

#include    "splash.h"
#define     FADE_STEPS  49

/*****************************************************************************/

void do_splash()
{
    int     fade_count;
    int     blend_factor;
    BITMAP  *splash_one;
    BITMAP  *splash_two;
                                                
    // load images
    if (exists("./gfx/splash/splash.pcx"))
    {
        splash_one = load_bitmap("./gfx/splash/splash.pcx", NULL);
    }
    else
    {
        splash_one = create_bitmap(2, 2);
        DUH_WHERE_AM_I("missing asset: ./gfx/splash/splash.pcx");
    }

    if (exists("./gfx/splash/splash2.pcx"))
    {
        splash_two = load_bitmap("./gfx/splash/splash2.pcx", NULL);
    }
    else
    {
        splash_two = create_bitmap(2, 2);
        DUH_WHERE_AM_I("missing asset: ./gfx/splash/splash2.pcx");
    }
                                                
    // fading in...
    for(fade_count = 0; fade_count < FADE_STEPS; fade_count++)
    {
        blend_factor = (fade_count * 6);
        if (blend_factor > 255)
            blend_factor = 255;

        while (!time_for_logic);                        

        clear_bitmap(double_buffer);                                            
        set_trans_blender(255, 255, 255, blend_factor);                                                            
        draw_trans_sprite(double_buffer, splash_one, 
            (double_buffer->w - splash_one->w) / 2, 
            (double_buffer->h - splash_one->h) / 2);      

        time_for_logic = FALSE;
        COMMON_flip_buffer();
    }

    // hold...
    rest(2000);

    // cross fade to second image...
    for(fade_count = 0; fade_count < FADE_STEPS; fade_count++)
    {
        blend_factor = (fade_count * 6);
        if (blend_factor > 255)
            blend_factor = 255;

        while (!time_for_logic);


        set_trans_blender(255, 255, 255, blend_factor);
        draw_sprite(double_buffer, splash_one, (double_buffer->w - splash_one->w) / 2, (double_buffer->h - splash_one->h) / 2);
        draw_trans_sprite(double_buffer, splash_two, 
            (double_buffer->w - splash_two->w) / 2, 
            (double_buffer->h - splash_two->h) / 2);

        time_for_logic = 0;
        COMMON_flip_buffer();
    }

    // hold...
    rest(2000);

    // fade out...
    for(fade_count = 0; fade_count < FADE_STEPS; fade_count++)
    {
        blend_factor = 255 - (fade_count * 6);
        if (blend_factor < 0)
            blend_factor = 0;

        while(!time_for_logic);

        set_trans_blender(255, 255, 255, blend_factor);
        clear_bitmap(double_buffer);
        draw_trans_sprite(double_buffer, splash_two, (double_buffer->w - splash_two->w) / 2, (double_buffer->h - splash_two->h) / 2);

        time_for_logic = 0;
        COMMON_flip_buffer();
    }

    destroy_bitmap(splash_one);
    destroy_bitmap(splash_two);
}

